#ifndef _XHANABI_ColorGC_h_INCLUDED_
#define _XHANABI_ColorGC_h_INCLUDED_

typedef struct _ColorGCList * ColorGCList;
typedef struct _ColorGC * ColorGC;

#include "Disp.h"
#include "Obj.h"
#include "Stream.h"

#define RGB_MAX_VALUE 65535

ColorGCList ColorGCList_Create(Disp disp);
ColorGCList ColorGCList_Destroy(ColorGCList list);
ColorGC ColorGC_Create(Disp disp, ColorGCList list, XColor color);
ColorGC ColorGC_CreateFromCharacters(Disp disp, ColorGCList list, char * name);
ColorGC ColorGC_CreateFromRGB(Disp disp, ColorGCList list,
			      int red, int green, int blue);
ColorGC ColorGC_Destroy(ColorGC color_gc);
GC ColorGC_GetGC(ColorGC color_gc);
int ColorGC_GetBrightness(ColorGC color_gc);
ObjList CreateColorGCListFromCharacters(Disp disp, ColorGCList color_gc_list,
					char * data, char * background,
					int after_image_length);

#endif

/* End of File */
