#include "XHanabiP.h"

XHanabi XHanabi_Create(char * display_name, char * background_color)
{
  XHanabi xhanabi;
  Stream stream;

  xhanabi = (XHanabi)malloc(sizeof(_XHanabi));
  if (!xhanabi) Error("XHanabi_Create", "Cannot allocate mamory");

  /*  */
  InitializeRand();

  xhanabi->disp = Disp_Create(display_name, background_color);

  /* TamaClass ɤ߹ */
  stream = Stream_CreateFromFile("xhanabi.conf");

  xhanabi->color_gc_list = ColorGCList_Create(xhanabi->disp);

  xhanabi->tama_class_list =
    TamaClassList_CreateFromStream(xhanabi->disp, xhanabi->color_gc_list,
				   stream, background_color);
  Stream_Destroy(stream);

  xhanabi->tamas_list = ObjList_Create();
  xhanabi->after_images_list = ObjList_Create();

  return (xhanabi);
}

int XHanabi_Destroy(XHanabi xhanabi)
{
  if (!xhanabi) return (0);
  if (xhanabi->tama_class_list) ObjList_Destroy(xhanabi->tama_class_list);
  if (xhanabi->tamas_list) ObjList_Destroy(xhanabi->tamas_list);
  if (xhanabi->after_images_list) ObjList_Destroy(xhanabi->after_images_list);
  if (xhanabi->color_gc_list) ColorGCList_Destroy(xhanabi->color_gc_list);
  if (xhanabi->disp) Disp_Destroy(xhanabi->disp);
  free(xhanabi);
  return (0);
}

static int XHanabi_DrawAllTamaClasses(XHanabi xhanabi)
{
  TamaClass tama_class;
  ObjList gc_list_list;
  ObjList gc_list;
  ObjListData a, b, c;
  GC gc;

  int x, y;

  x = 10;
  y = 10;

  for (a = ObjList_GetStart(xhanabi->tama_class_list);
       !ObjList_IsEndEdge(xhanabi->tama_class_list, a);
       a = ObjListData_GetNext(a)) {
    tama_class = (TamaClass)ObjListData_GetObj(a);
    gc_list_list = TamaClass_GetGCListList(tama_class);

    for (b = ObjList_GetStart(gc_list_list);
	 !ObjList_IsEndEdge(gc_list_list, b);
	 b = ObjListData_GetNext(b)) {

      gc_list = ObjListData_GetObj(b);

      x = 10;
      for (c = ObjList_GetStart(gc_list);
	   !ObjList_IsEndEdge(gc_list, c);
	   c = ObjListData_GetNext(c)) {
	gc = ColorGC_GetGC(ObjListData_GetObj(c));
	Disp_DrawFilledCircle(xhanabi->disp, gc, x, y, 5);
	Disp_Flush(xhanabi->disp);
	x += 10;
      }
      y += 10;
    }
  }
  return (0);
}

int XHanabi_Start(XHanabi xhanabi)
{
  TamaClass tama_class;
  Tamas tamas;
  TamaNext tama_next;
  ObjList next_list;
  ObjListData current;
  ObjListData current2;
  AfterImages after_images;
  int i;
  double d;
  double x, y, vx, vy;
  /*
  XHanabi_DrawAllTamaClasses(xhanabi);
  while(1){}
  */

  while (1) {

    /*  Tamas  */
    if (ObjList_GetLength(xhanabi->tamas_list) < TAMA_MAX) {

      for (current = ObjList_GetStart(xhanabi->tama_class_list);
	   !ObjList_IsEndEdge(xhanabi->tama_class_list, current);
	   current = ObjListData_GetNext(current)) {
	tama_class = (TamaClass)ObjListData_GetObj(current);
	if (TamaClass_GetProbability(tama_class) > 0.0) {
	  if (TamaClass_GetProbability(tama_class) > DoubleRand(100.0)) {
	    x = (double)Rand(Disp_GetWidth( xhanabi->disp));
	    y = (double)Rand(Disp_GetHeight(xhanabi->disp));
	    vx = 0.0;
	    vy = 0.0;
	    y -= Disp_GetHeight(xhanabi->disp) / 4;

	    tamas = Tamas_Create(tama_class, 0.0, 1, 1, &x, &y, &vx, &vy,
				 0, 0, 
				 Disp_GetWidth( xhanabi->disp) - 1,
				 Disp_GetHeight(xhanabi->disp) - 1);
	    ObjList_InsertObjToEnd(xhanabi->tamas_list,
				   tamas,
				   (ObjDestructor)Tamas_Destroy);

	  }
	}
      }
    }

    /* Tamas ν */
    for (current = ObjList_GetStart(xhanabi->tamas_list);
	 !ObjList_IsEndEdge(xhanabi->tamas_list, current);
	 current = ObjListData_GetNext(current)) {

      tamas = (Tamas)ObjListData_GetObj(current);
      tama_class = Tamas_GetTamaClass(tamas);

      after_images = Tamas_Move(tamas,
				0, 0, 
				Disp_GetWidth( xhanabi->disp) - 1,
				Disp_GetHeight(xhanabi->disp) - 1,
				Disp_GetWidth( xhanabi->disp));
      if (after_images == NULL) { /* ǳԤ */
	next_list = TamaClass_GetNextList(tama_class);
	if (next_list) {
	  for (current2 = ObjList_GetStart(next_list);
	       !ObjList_IsEndEdge(next_list, current2);
	       current2 = ObjListData_GetNext(current2)) {
	    tama_next = (TamaNext)ObjListData_GetObj(current2);

	    ObjList_InsertObjToEnd(xhanabi->tamas_list,
				   Tamas_Create(TamaNext_GetTamaClass(tama_next),
						TamaNext_GetPower(tama_next),
						TamaNext_GetNumber(tama_next),
						Tamas_GetNumber(tamas),
						Tamas_GetX(tamas),
						Tamas_GetY(tamas),
						Tamas_GetVx(tamas),
						Tamas_GetVy(tamas),
						0, 0, 
						Disp_GetWidth( xhanabi->disp) - 1,
						Disp_GetHeight(xhanabi->disp) - 1),
				   (ObjDestructor)Tamas_Destroy);
	  }
	}
	current = ObjList_DeleteObjToPrev(xhanabi->tamas_list, current);
      } else {
	ObjList_InsertObjToEnd(xhanabi->after_images_list, after_images,
			       (ObjDestructor)AfterImages_Destroy);
      }
    }

    /* ν */
    for (current = ObjList_GetStart(xhanabi->after_images_list);
	 !ObjList_IsEndEdge(xhanabi->after_images_list, current);
	 current = ObjListData_GetNext(current)) {
      after_images = (AfterImages)ObjListData_GetObj(current);

      if (AfterImages_IsEnd(after_images)) {
	current = ObjList_DeleteObjToPrev(xhanabi->after_images_list, current);
      } else {
	Disp_DrawFilledCircles(xhanabi->disp,
			       AfterImages_GetGC(after_images),
			       AfterImages_GetArcs(after_images),
			       AfterImages_GetNumber(after_images));

	/*usleep(10);*/
	/* X ФϢ³٤ͿʤΥ */

	AfterImages_MoveNext(after_images);
      }
    }

    Disp_Flush(xhanabi->disp);
    usleep(10);
  }

  return (0);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
